#include "Flower.h"
#include "testFlower.h"

using namespace std;


void fixedObjects(){
	Flower f1;				//default constructor
	f1.setName("daisy");
	f1.setPrice(5);

	Flower f2("tulip", 10);	//constr with param
	Flower f3("rose", 15);	//constr with param

	char* s1 = f1.toString();
	cout << s1 << endl;		//daisy-5

	char* s2 = f2.toString();
	cout << s2 << endl;		//tulip-10
	
	char* s3 = f3.toString();
	cout << s3 << endl;		//rose-15

	if (s3){
		delete[] s3;
		s3 = NULL;
	}
	if (s2){
		delete[] s2;
		s2 = NULL;
	}
	if (s1){
		delete[] s1;
		s1 = NULL;
	}
	//destructor for f3
	//destructor for f2
	//destructor for f1
}

void dinamicObjects(){
	Flower* pf1 = new Flower();	//default constr
	pf1->setName("daffodil");
	pf1->setPrice(1);

	Flower* pf2 = new Flower("hyacinth", 3);	//constr with param
	char* s1 = pf1->toString();
	cout << s1 << endl;
	char* s2 = pf2->toString();
	cout << s2 << endl;
	
	if (s2){
		delete[] s2;
		s2 = NULL;
	}
	if (s1){
		delete[] s1;
		s1 = NULL;
	}

	if (pf2){
		delete pf2;	//destructor
		pf2 = NULL;
	}
	if (pf1){
		delete pf1;	//destructor
		pf1 = NULL;
	}
}

void printFlowerWithoutRef(Flower f){
	char* s = f.toString();
	cout << "flower is : " << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}
}

void printFlowerWithRef(Flower &f){
	char* s = f.toString();
	cout << "flower is : " << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}	
}

void printFlowerPointer(Flower* f){
	char* s = f->toString();
	cout << "flower is : " << s << endl;
	if (s){
		delete[] s;
		s = NULL;
	}	
}

void objectAsParam(){
	Flower f1("peony", 6);
	Flower f2("lily", 7);
	Flower* pf1 = new Flower("jasmine", 8);

	printFlowerWithoutRef(f1);	//call copy-constr
	printFlowerWithRef(f2);		//not call copy-constr
	printFlowerPointer(pf1);	//not call copy-constr

	if(pf1){
		delete pf1;
		pf1 = NULL;
	}
}

void assignObjects(){
	Flower f1("peony", 6);
	Flower f2 = f1;					//call copy-constructor
	char* s1 = f1.toString();
	cout << s1 << endl;
	char* s2 = f2.toString();
	cout << s2 << endl;				//s1 == s2


	Flower* pf1 = new Flower(f1);	//call copy-constructor
	char* s3 = pf1->toString();
	cout << s3 << endl;				//s1 == s2 == s3

	if (s3){
		delete[] s3;
		s3 = NULL;
	}
	if (pf1){
		delete pf1;
		pf1 = NULL;
	}
	if (s2){
		delete[] s2;
		s2 = NULL;
	}
	if (s1){
		delete[] s1;
		s1 = NULL;
	}
}

int main1(){
	tests();
	fixedObjects();
	dinamicObjects();
	objectAsParam();
	assignObjects();

	//Flower f("rose", 2);
	//f.getName() = "daisy";
	return 0;
}


