#include <fstream>
#include <iostream>

using namespace std;

const int MAX = 100;

//Descr: read an integer from a file given by its [path+]name
//In: [path+]name of file
//Out: the read integer number
void readNo(int &n, char* fileName){
	ifstream fin;
	fin.open(fileName);
	if (fin){
		fin >> n;
		fin.close();	
	}
	else
		cout << "input file error..." << endl;
}

//Descr: print an integer into a file
//In: an integer number (n) and a [path+]name of file
//Out:  - (printing)
void printNo(int n, char* fileName){
	ofstream fout;
	fout.open(fileName);
	if (fout){
		fout << n << endl;
		fout.close();
	}
	else
		cout << "output file error..." << endl;
}

//Descr: read a string from a file given by its [path+]name
//In: [path+]name of file
//Out: the read string (word)
void readWord(char* w, char* fileName){
	ifstream fin;
	fin.open(fileName);
	if (fin){
		fin >> w;	//the memory was already allocated (out of this function)
		fin.close();
	}
	else
		cout << "input file error..." << endl;
}

//Descr: print a string into a file
//In: a string (w) and a [path+]name of file
//Out:  - (printing)
void printWord(char* w, char* fileName){
	ofstream fout;
	fout.open(fileName);
	if (fout){
		fout << w << endl;
		fout.close();
	}
	else
		cout << "output file error..." << endl;
}

//Descr: read more lines from a file given by its [path+]name
//In: [path+]name of file
//Out: the read lines and their no (noLines)
void readMoreLines(char** lines, int &noLines, char* fileName){
	ifstream fin;
	fin.open(fileName);
	if (fin){
		noLines = 0;
		while(!fin.eof()){
			fin.getline(lines[noLines++], MAX);
		}
		fin.close();
	}
	else
		cout << "input file error..." << endl;
}

//Descr: print more strings into a file
//In: more strings/lines (l), their number (noLines) and a [path+]name of file
//Out:  - (printing)
void printMoreLines(char** l, int noLines, char* fileName){
	ofstream fout;
	fout.open(fileName);
	if (fout){
		for(int i = 0; i < noLines; i++)
			fout << l[i] << endl;
		fout.close();
	}
	else
		cout << "output file error..." << endl;
}


int main(){
	int x = 0;
	readNo(x, "D:\\_Work\\School\\_2016-2017\\sem2\\POO\\lectures\\03\\files\\dataNo.in");
	printNo(x, "D:\\_Work\\School\\_2016-2017\\sem2\\POO\\lectures\\03\\files\\dataNo.out");

	char* w = new char[MAX];
	readWord(w, "D:\\_Work\\School\\_2016-2017\\sem2\\POO\\lectures\\03\\files\\dataWord.in");
	printWord(w, "D:\\_Work\\School\\_2016-2017\\sem2\\POO\\lectures\\03\\files\\dataWord.out");
	if (w != NULL){
		delete[] w;
		w = NULL;
	}

	char** lines = new char*[MAX];
	for(int i = 0; i < MAX; i++)
		lines[i] = new char[MAX];
	int n;
	readMoreLines(lines, n, "D:\\_Work\\School\\_2016-2017\\sem2\\POO\\lectures\\03\\files\\dataLines.in");
	printMoreLines(lines, n, "D:\\_Work\\School\\_2016-2017\\sem2\\POO\\lectures\\03\\files\\dataLines.out");
	for(int i = 0; i < MAX; i++)
		if (lines[i] != NULL){
			delete[] lines[i];
			lines[i] = NULL;
		}
	if (lines != NULL){
		delete[] lines;
		lines = NULL;
	}

	return 0;
}